; ver.2.2
;MATH LIBRARY BY MARTIN HANKOVEC (NEGATRON RESEARCH) FOR FLOATING POINT OPERATIONS
;(C)1998-2003
;
$mod51
fp_invert:
        push    acc
        mov     a,@r0
        jz      fp_in1
        mov     @r0,#0
        pop     acc
        ret
fp_in1: mov     @r0,#0FFh
        pop     acc
        ret
fp_exch:push    acc
        mov     a,r7
        push    acc
        mov     r7,#5
fp_ex1:
        mov     a,@r0
        xch     a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        djnz    r7,fp_ex1
        mov     a,r0
        clr     c
        subb    a,#5
        mov     r0,a
        mov     a,r1
        clr     c
        subb    a,#5
        mov     r1,a
        pop     acc
        mov     r7,a
        pop     acc
        ret
fp_0:
        mov     @r0,#0
        inc     r0
        mov     @r0,#0
        inc     r0
        mov     @r0,#0
        inc     r0
        mov     @r0,#0
        inc     r0
        mov     @r0,#80h
        dec     r0
        dec     r0
        dec     r0
        dec     r0
        ret
fp_PI:
        mov     @r0,#0
        inc     r0
        mov     @r0,#02fh
        inc     r0
        mov     @r0,#0efh
        inc     r0
        mov     @r0,#0d8h
        inc     r0
        mov     @r0,#7ah
        dec     r0
        dec     r0
        dec     r0
        dec     r0
        ret
fp_1:
        mov     @r0,#0
        inc     r0
        mov     @r0,#01
        inc     r0
        mov     @r0,#86h
        inc     r0
        mov     @r0,#0A0h
        inc     r0
        mov     @r0,#7bh
        dec     r0
        dec     r0
        dec     r0
        dec     r0
        ret
fp_2:
        mov     @r0,#0
        inc     r0
        mov     @r0,#03
        inc     r0
        mov     @r0,#0dh
        inc     r0
        mov     @r0,#040h
        inc     r0
        mov     @r0,#7bh
        dec     r0
        dec     r0
        dec     r0
        dec     r0
        ret
fp_10:
        mov     @r0,#0
        inc     r0
        mov     @r0,#01
        inc     r0
        mov     @r0,#86h
        inc     r0
        mov     @r0,#0A0h
        inc     r0
        mov     @r0,#7ch
        dec     r0
        dec     r0
        dec     r0
        dec     r0
        ret
fp_sign:mov     a,r0
        push    acc
        mov     fp_stack,@r0
        inc     r0
        mov     a,@r0
        jnz     fp_sign1
        inc     r0
        mov     a,@r0
        jnz     fp_sign1
        inc     r0
        mov     a,@r0
        jnz     fp_sign1
        inc     r0
        mov     @r0,#80h
        dec     r0
        mov     @r0,#0
        dec     r0
        mov     @r0,#0
        dec     r0
        mov     @r0,#0
        dec     r0
        mov     @r0,#0
        pop     acc
        mov     r0,a
        clr     a
        ret
fp_sign1:
        pop     acc
        mov     r0,a
        mov     a,fp_stack
        jnz     fp_sign2
        mov     a,#01
fp_sign2:
        ret
fp_comp:
        mov     a,r2
        push    acc
        mov     a,r7
        push    acc
        mov     a,r4
        push    acc
        mov     a,r1
        push    acc
        mov     a,r0
        push    acc
        mov     a,@r0
        xrl     a,@r1
        jz      fp_comp1

        mov     a,@r0
        clr     c
        subb    a,@r1
        jc      fp_comp20
        ljmp    fp_comp3b
fp_comp20:ljmp  fp_comp2b
fp_comp1:
        lcall   smaz_stack
        mov     a,r1
        add     a,#3
        mov     r1,a
        mov     r0,#fp_stack+15
        lcall   fp_kopie
        mov     a,r1
        add     a,#4
        push    acc
        mov     r4,#3
        lcall   fp_normal2
        pop     acc
        mov     r0,a
        dec     r0
        mov     r1,#fp_stack+15
        lcall   fp_kopie

        lcall   smaz_stack
        pop     acc
        push    acc
        add     a,#3
        mov     r1,a
        mov     r0,#fp_stack+15
        lcall   fp_kopie
        mov     a,r1
        add     a,#4
        push    acc
        mov     r4,#3
        lcall   fp_normal2
        pop     acc
        mov     r0,a
        dec     r0
        mov     r1,#fp_stack+15
        lcall   fp_kopie
        pop     acc
        mov     r0,a
        pop     acc
        mov     r1,a
        push    acc
        mov     a,r0
        push    acc
        lcall   smaz_stack
        mov     a,r0
        add     a,#4
        mov     r0,a
        mov     a,r1
        add     a,#4
        mov     r1,a
        mov     a,@r0
        clr     c
        subb    a,@r1
        jc      fp_addl20
        mov     r2,a
        mov     a,r0
        mov     r4,a
        mov     a,r1
        mov     r0,a
        sjmp    fp_addl40
fp_addl20:
        cpl     a
        inc     a
        mov     r2,a
        mov     a,r1
        mov     r4,a
fp_addl40:
        mov     r7,#3
        mov     r1,#fp_stack+16
fp_addl30:
        dec     r1
        dec     r0
        mov     a,@r0
        mov     @r1,a
        djnz    r7,fp_addl30
        mov     a,r2
        jz      fp_addi_ok0
        lcall   fp_norma2
fp_addi_ok0:
        mov     a,r4
        clr     c
        subb    a,#3
        mov     r0,a
        dec     a
        mov     r4,a
        mov     a,@r0
        clr     c
        subb    a,fp_stack+13
        jc      fp_comp3
        jnz     fp_comp2
        inc     r0
        mov     a,@r0
        clr     c
        subb    a,fp_stack+14
        jc      fp_comp3
        jnz     fp_comp2
        inc     r0
        mov     a,@r0
        clr     c
        subb    a,fp_stack+15
        jc      fp_comp3
        jz      fp_rovno

fp_comp2:
        pop     acc
        push    acc
        mov     r0,a
        xrl     a,r4
        jz      fp_comp2a
        mov     a,@r0
        jnz     fp_comp2b
        sjmp    fp_comp3b
fp_comp2a:
        mov     a,@r0
        jz      fp_comp2b
        sjmp    fp_comp3b

fp_comp3:
        pop     acc
        push    acc
        mov     r0,a
        xrl     a,r4
        jz      fp_comp3a
        mov     a,@r0
        jnz     fp_comp3b
        sjmp    fp_comp2b
fp_comp3a:
        mov     a,@r0
        jz      fp_comp3b
        sjmp    fp_comp2b
fp_comp3b:
        mov     fp_stack,#0FFh
        sjmp    fp_compnec
fp_comp2b:
        mov     fp_stack,#01h
        sjmp    fp_compnec
fp_rovno:
        mov     fp_stack,#0
fp_compnec:
        pop     acc
        mov     r0,a
        pop     acc
        mov     r1,a
        pop     acc
        mov     r4,a
        pop     acc
        mov     r7,a
        pop     acc
        mov     r2,a
        mov     a,fp_stack
        ret
fp_kopie:
        mov     r7,#3
fp_kopie1:mov   a,@r1
        mov     @r0,a
        dec     r0
        dec     r1
        djnz    r7,fp_kopie1
        ret
fp_copy:
        push    acc
        mov     a,r7
        push    acc
        mov     r7,#5
fp_copy1:mov    a,@r0
        mov     @r1,a
        inc     r0
        inc     r1
        djnz    r7,fp_copy1
        mov     a,r0
        clr     c
        subb    a,#5
        mov     r0,a
        mov     a,r1
        clr     c
        subb    a,#5
        mov     r1,a
        pop     acc
        mov     r7,a
        pop     acc
        ret
fp_print_fix:
        push    acc
        mov     a,r7
        push    acc
        mov     a,r4
        push    acc
        mov     a,r1
        push    acc
        mov     a,r0
        push    acc
        lcall fp_toascii
        mov     r7,#8
        mov     r1,#fp_stack+8
fp_prnnex0:
        mov     @r1,#'0'
        inc     r1
        djnz    r7,fp_prnnex0
        pop     acc
        push    acc
        add a,#4
        mov r0,a
        mov a,@r0
        mov r4,a
        cjne    a,#80h,fp_prnnex1
        sjmp fp_prnnex2
fp_prnnex1:
        jc fp_prnnex7
fp_prnnex9:
        mov r7,#15
        mov r0,#fp_stack+15
        mov a,#'0'
fp_prnnex8:
        xch a,@r0
        dec r0
        djnz r7,fp_prnnex8
        xrl a,#'0'
        jnz fp_prnneEx
        dec r4
        cjne r4,#80h,fp_prnnex9
        sjmp fp_prnnex2
fp_prnnex7:
        mov r7,#16
        mov r0,#fp_stack
        mov a,#'0'
fp_prnnex10:
        xch a,@r0
        inc r0
        djnz r7,fp_prnnex10
        inc r4
        cjne r4,#80h,fp_prnnex7
        cjne a,#'5',fp_prnnex11
fp_prnnex11:
        jc fp_prnnex2

fp_prnnex12:
        dec r0
        mov a,@r0
        cjne a,#'9',fp_prnnex13
        mov @r0,#'0'
        sjmp fp_prnnex12
fp_prnnex13:
        inc @r0
        sjmp fp_prnnex2
fp_prnneex:
        setb    c
        ljmp    fp_print9
fp_prnnex2:
        pop     acc
        mov     r0,a
        pop     acc
        mov     r1,a
        push    acc
        mov     a,r0
        push    acc
        mov     a,r1
        jnz     fp_prnnex21
        sjmp    fp_prnne2
fp_prnnex21:

        mov r7,#16
        mov r0,#fp_stack
fp_prnnex211:
        mov     a,@r0
        xrl     a,#'0'
        jnz     fp_prnnex212
        inc     r0
        djnz    r7,fp_prnnex211
        sjmp    fp_prnnex213
fp_prnnex212:

        pop     acc
        push    acc
        mov     r0,a
        mov     a,@r0
        jz      fp_prnnex213
        mov     @r1,#'-'
        inc     r1
        sjmp    fp_prnnex214
fp_prnnex213:
        mov     @r1,#' '
        inc     r1
fp_prnnex214:
        mov     r7,#16
        mov     r0,#fp_stack
fp_prnnex22:
        mov     a,@r0
        mov     @r1,a
        inc     r0
        inc     r1
        djnz    r7,fp_prnnex22
        clr     c
        ljmp    fp_print9
fp_prnnez:
        mov     r7,#8
        mov     r1,#fp_stack+8
fp_prnne0:
        mov     @r1,#'0'
        inc     r1
        djnz    r7,fp_prnne0
        pop     acc
        push    acc
        add a,#4
        mov r0,a
        mov a,@r0
        mov r4,a
        cjne    a,#80h,fp_prnne1
        sjmp fp_prnne2
fp_prnne1:
        jc fp_prnne7
fp_prnne9:
        mov r7,#15
        mov r0,#fp_stack+15
        mov a,#'0'
fp_prnne8:
        xch a,@r0
        dec r0
        djnz r7,fp_prnne8
        xrl a,#'0'
        jnz fp_prnneE
        dec r4
        cjne r4,#80h,fp_prnne9
        sjmp fp_prnne2
fp_prnne7:
        mov r7,#16
        mov r0,#fp_stack
        mov a,#'0'
fp_prnne10:
        xch a,@r0
        inc r0
        djnz r7,fp_prnne10
        xrl a,#'0'
        jnz fp_prnneE
        inc r4
        cjne r4,#80h,fp_prnne7
        sjmp fp_prnne2
fp_prnnee:
        ljmp    fp_print15

fp_prnne2:
        mov r7,#16
        mov r0,#fp_stack
fp_prnne20:
        mov     a,@r0
        xrl     a,#'0'
        jnz     fp_prnne21
        inc     r0
        djnz    r7,fp_prnne20
        sjmp    fp_prnne3
fp_prnne21:
        pop acc
        push acc
        mov r0,a
        mov a,@r0
        jz fp_prnne3
        mov a,#'-'
        lcall fp_posli
fp_prnne3:
        mov r7,#7
        mov r0,#fp_stack
fp_prnne5:
        mov a,@r0
        xrl a,#'0'
        jnz fp_prnne51
        inc r0
        djnz    r7,fp_prnne5
        sjmp    fp_prnne4
fp_prnne51:
        mov a,@r0
        lcall fp_posli
        inc r0
        djnz r7,fp_prnne51
fp_prnne4:
        mov a,@r0
        lcall fp_posli
        mov r7,#8
        mov r1,#fp_stack+15
fp_prnne40:
        mov a,@r1
        xrl a,#'0'
        jnz fp_prnne41
        dec r1
        djnz r7,fp_prnne40
        clr     c
        ljmp fp_print9
fp_prnne41:
        inc r0
        mov a,#'.'
        lcall fp_posli
fp_prnne6:
        mov a,@r0
        lcall fp_posli
        inc r0
        djnz r7,fp_prnne6
        clr     c
        ljmp    fp_print9
fp_print:
        push    acc
        mov     a,r7
        push    acc
        mov     a,r4
        push    acc
        mov     a,r1
        push    acc
        mov     a,r0
        push    acc
        lcall fp_toascii
        ljmp    fp_prnnez
fp_print15:
        pop     acc
        push    acc
        mov     r0,a
        lcall fp_toascii
        sjmp    fp_print16
fp_print_exp:
        push    acc
        mov     a,r7
        push    acc
        mov     a,r4
        push    acc
        mov     a,r1
        push    acc
        mov     a,r0
        push    acc
        lcall fp_toascii
fp_print16:
        mov     fp_stack+8,#0ffh
        mov     r0,#fp_stack
fp_print6:
        mov     a,@r0
        inc     r0
        xrl     a,#'0'
        jz      fp_print6
        mov     a,r0
        cjne    a,#fp_stack+9,fp_print60
        mov     a,#'0'
        lcall   fp_posli
        clr     c
        ljmp    fp_print9
fp_print60:
        mov     fp_stack+14,a
        clr     c
        subb    a,#fp_stack
        mov     r7,a
        mov     a,#8
        clr     c
        subb    a,r7
        mov     fp_stack+15,a
        mov     fp_stack+8,#0
        mov     fp_stack+12,#0
        mov     fp_stack+13,#1
        pop     acc
        push    acc
        add     a,#4
        mov     r0,a
        mov     a,@r0
        add     a,fp_stack+15
        mov     fp_stack+15,a
        mov     a,r0
        clr     c
        subb    a,#4
        mov     r0,a
        mov     a,@r0
        jz      fp_print7
        mov     a,#'-'
        lcall   fp_posli
fp_print7:
        mov     r0,fp_stack+14
        dec     r0
        mov     a,@r0
        lcall   fp_posli
        inc     r0
        mov     a,#'.'
        lcall   fp_posli
        mov     a,fp_stack+14
        cjne    r0,#fp_stack+8,fp_print14
        mov     a,#'0'
        lcall   fp_posli
fp_print14:
        mov     a,@r0
fp_print8:
        lcall   fp_posli
        inc     r0
        mov     a,@r0
        jnz     fp_print8
        mov     a,fp_stack+15
        xrl     a,#80h
        clr     c
        jz      fp_print9
        mov     a,#' '
        lcall   fp_posli
        mov     a,#'E'
        lcall   fp_posli
        mov     a,#' '
        lcall   fp_posli
        mov     a,fp_stack+15
        jb      acc.7,fp_print10
        mov     a,#'-'
        lcall   fp_posli
        mov     a,#80h
        clr     c
        subb    a,fp_stack+15
        add     a,#80h
fp_print10:
        clr     c
        subb    a,#80h
        mov     fp_stack+15,a
        mov     r7,#8
fp_print11:
        mov     a,fp_stack+15
        rrc     a
        mov     fp_stack+15,a
        jnc     fp_print12
        mov     a,fp_stack+13
        add     a,fp_stack+11
        da      a
        mov     fp_stack+11,a
        mov     a,fp_stack+12
        addc    a,fp_stack+10
        da      a
        mov     fp_stack+10,a
fp_print12:
        mov     a,fp_stack+13
        add     a,fp_stack+13
        da      a
        mov     fp_stack+13,a
        mov     a,fp_stack+12
        addc    a,fp_stack+12
        da      a
        mov     fp_stack+12,a
        djnz    r7,fp_print11
        mov     a,fp_stack+10
        jz      fp_print13
        add     a,#'0'
        lcall   fp_posli
fp_print13:
        mov     a,fp_stack+11
        anl     a,#0f0h
        swap    a
        add     a,#'0'
        lcall   fp_posli
        mov     a,fp_stack+11
        anl     a,#0fh
        add     a,#'0'
        lcall   fp_posli
        clr     c
fp_print9:
        pop     acc
        mov     r0,a
        pop     acc
        mov     r1,a
        pop     acc
        mov     r4,a
        pop     acc
        mov     r7,a
        pop     acc
        ret
fp_posli:
        jnb     ti,$
        mov     sbuf,a
        clr     ti
        ret
FP_MUL:
        push    acc
        mov     a,r2
        push    acc
        mov     a,r4
        push    acc
        mov     a,r6
        push    acc
        mov     a,r7
        push    acc
        LCALL   SMAZ_STACK
        MOV     A,R0
        PUSH    ACC
        ADD     A,#3
        MOV     R2,A
        MOV     A,R1
        ADD     A,#3
        PUSH    ACC
        MOV     R1,A
        MOV     R4,#fp_stack+7
        MOV     R6,#3
fp_mul3:
        MOV     R7,#3
fp_mul1:


        MOV     A,R2
        MOV     R0,A
        MOV     B,@R0
        mov     a,r4
        MOV     R0,A
        MOV     A,@R1
        MUL     ab
        add     a,@r0
        mov     @r0,a
        mov     a,b
        addc    a,#0
        dec     r0
        mov     @r0,a
        dec     r4
        dec     r2
        djnz    r7,fp_mul1


        mov     r7,#8
        mov     r0,#fp_stack+7
        mov     r1,#fp_stack+15
        clr     c
fp_mul4:
        mov     a,@r0
        addc    a,@r1
        mov     @r1,a
        dec     r0
        dec     r1
        djnz    r7,fp_mul4


        lcall   smaz_pul_stack
        pop     acc
        dec     a
        mov     r1,a
        push    acc
        mov     a,r2
        add     a,#3
        mov     r2,a
        mov     a,r4
        add     a,#2
        mov     r4,a
        djnz    r6,fp_mul3



        pop     acc
        mov     r1,a
        pop     acc
        mov     r0,a
        push    acc
        mov     a,r1
        push    acc
        mov     a,r0
        add     a,#4


        mov     r4,#6
        lcall   fp_normalizace

        POP     ACC
        MOV     R1,A
        POP     ACC
        MOV     R0,A
        mov     a,r1
        mov     r2,a
        mov     a,@r1
        xrl     a,@r0
        mov     @r0,a
        inc     r0
        mov     r7,#3
        mov     r1,#fp_stack+13
fp_mul6:
        mov     a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        djnz    r7,fp_mul6
        mov     a,r2
        add     a,#4
        mov     r1,a
        mov     a,@r1
        clr     c
        subb    a,#80h
        add     a,@r0
        clr     c
        mov     @r0,a
        mov     a,r0
        subb    a,#4
        mov     r0,a
        mov     a,r1
        clr     c
        subb    a,#4
        mov     r1,a

        pop     acc
        mov     r7,a
        pop     acc
        mov     r6,a
        pop     acc
        mov     r4,a
        pop     acc
        mov     r2,a
        pop     acc
        RET
fp_normalizace:
        push    acc
fp_norma:

        mov     r7,#0
        mov     r1,#fp_stack+7
fp_mul2:                                  ;xx1
        inc     r1
        inc     r7
        mov     a,@r1
        jz      fp_mul2
        cjne    r4,#6,fp_mul7

        cjne    r7,#6,fp_mul5
        sjmp    fp_mul5
fp_mul7:cjne    r7,#7,fp_mul5
fp_mul5:
        jc      fp_mul_zmensi
        pop     acc

        ret
fp_mul_zmensi:


        clr     c
        mov     a,#9
        subb    a,r7
        mov     r7,a
        mov     r2,a
        mov     r0,#fp_stack
        mov     b,#0
fp_mul_zmensi1:
        mov     a,b
        swap    a
        mov     b,a
        mov     a,@r1
        anl     a,#0f0h
        swap    a
        orl     a,b

        mov     b,#0ah
        div     ab
        anl     a,#0fh
        swap    a
        mov     @r0,a
        mov     a,b
        swap    a
        mov     b,a
        mov     a,@r1
        anl     a,#0fh
        orl     a,b

        mov     b,#0ah
        div     ab
        anl     a,#0fh
        orl     a,@r0
        mov     @r0,a
        inc     r0
        inc     r1
        djnz    r7,fp_mul_zmensi1
        lcall   smaz_pul2_stack
        mov     a,r0
        clr     c
        subb    a,#fp_stack
        mov     r7,a
        dec     r0
        mov     r1,#fp_stack+15
fp_mul_zmensi2:
        mov     a,@r0
        mov     @r1,a
        dec     r0
        dec     r1
        djnz    r7,fp_mul_zmensi2
        lcall   smaz_pul_stack
        pop     acc
        push    acc
        mov     r0,a
        inc     @r0
        ljmp    fp_norma
fp_normal2:
        push    acc
fp_normal:

        mov     r7,#0
        mov     r1,#fp_stack+7
fp_mull2:
        inc     r1
        inc     r7
        mov     a,@r1
        jz      fp_mull2
        cjne    r4,#3,fp_mull7

        cjne    r7,#7,fp_mull5
        sjmp    fp_mull5
fp_mull7:cjne   r7,#5,fp_mull5
fp_mull5:
        pop     acc
        push    acc
        jnc     fp_mul_zvetsi
        pop     acc

        ret
fp_mul_zvetsi:


        mov     r0,a
        dec     @r0
        mov     r0,#fp_stack+15
        mov     r2,#0
        mov     r7,#6
fp_mul_zvetsi1:
        mov     b,#0ah
        mov     a,@r0
        mul     ab
        add     a,r2
        JNC     pren                    ;doplneno
        INC     b                       ;doplneno
pren:   mov     @r0,a
        mov     r2,b
        dec     r0
        djnz    r7,fp_mul_zvetsi1
        mov     a,r2
        mov     @r0,a
        ljmp    fp_normal
fp_div:
        push    acc
        mov     a,r2
        push    acc
        mov     a,r7
        push    acc
        mov     a,r4
        push    acc
        mov     a,r1
        push    acc
        mov     a,r0
        push    acc
        mov     a,r1
        mov     r0,a
        lcall   fp_sign
        jnz     fp_divn
        setb    c
fp_divo:
        pop     acc
        mov     r0,a
        pop     acc
        mov     r1,a
        pop     acc
        mov     r4,a
        pop     acc
        mov     r7,a
        pop     acc
        mov     r2,a
        pop     acc
        ret
fp_divn:
        pop     acc
        push    acc
        mov     r0,a
        lcall   fp_sign
        jnz     fp_divm
        lcall   fp_0
        sjmp    fp_divo
fp_divm:
        lcall   smaz_stack
        mov     a,r1
        add     a,#3
        mov     r1,a
        mov     r0,#fp_stack+15
        mov     r7,#3
fp_div1:mov     a,@r1
        mov     @r0,a
        dec     r0
        dec     r1
        djnz    r7,fp_div1
        mov     a,r1
        add     a,#4
        push    acc
        mov     r4,#3
        lcall   fp_normal2
        mov     r7,#3
        mov     r0,#fp_stack+15
        mov     r1,#fp_stack+7
fp_div8:mov     a,@r0
        mov     @r1,a
        dec     r0
        dec     r1
        djnz    r7,fp_div8
        pop     acc
        dec     a
        mov     r0,a
        mov     r7,#3
        mov     r1,#fp_stack+7
fp_div11:mov    a,@r1
        mov     @r0,a
        dec     r0
        dec     r1
        djnz    r7,fp_div11
        lcall   smaz_pul2_stack
        pop     acc
        mov     r0,a
        push    acc
        inc     r0
        mov     r1,#fp_stack+13
        mov     r7,#3
fp_div9:mov     a,@r0
        mov     @r1,a
        inc     r0
        inc     r1
        djnz    r7,fp_div9
        mov     a,r0
        mov     r4,#6
        lcall   fp_normal2
        mov     r0,#fp_stack+15
        mov     r7,#24
fp_div3:
        clr     c
        mov     r4,#6
fp_div6:
        mov     a,@r0
        rlc     a
        mov     @r0,a
        dec     r0
        djnz    r4,fp_div6
        clr a
        rlc a
        mov fp_stack+9,a
        mov     r0,#fp_stack+12
        mov     a,@r0
        clr     c
        subb    a,fp_stack+7
        mov     @r0,a
        dec     r0
        mov     a,@r0
        subb    a,fp_stack+6
        mov     @r0,a
        dec     r0
        mov     a,@r0
        subb    a,fp_stack+5
        mov     @r0,a
        mov     r0,#fp_stack+12
        jc      fp_div2

fp_div4_0:
        setb    c
fp_div4:
        mov     r1,#fp_stack+2
        mov     a,@r1
        rlc     a
        mov     @r1,a
        dec     r1
        mov     a,@r1
        rlc     a
        mov     @r1,a
        dec     r1
        mov     a,@r1
        rlc     a
        mov     @r1,a
        sjmp    fp_div5
fp_div2:
        mov a,fp_stack+9
        jnz fp_div4_0
        mov     a,@r0
        add     a,fp_stack+7
        mov     @r0,a
        dec     r0
        mov     a,@r0
        addc    a,fp_stack+6
        mov     @r0,a
        dec     r0
        mov     a,@r0
        addc    a,fp_stack+5
        mov     @r0,a
        clr     c
        sjmp    fp_div4
fp_div5:
        mov     r0,#fp_stack+15
        djnz    r7,fp_div3
        pop     acc
        mov     r0,a
        inc     r0
        mov     r1,#fp_stack
        mov     r7,#3
fp_div10:
        mov     a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        djnz    r7,fp_div10
        pop     acc
        add     a,#4
        mov     r1,a
        mov     a,@r0
        clr     c
        subb    a,@r1
        add     a,#80h
        mov     @r0,a
        clr     c
        mov     a,r0
        subb    a,#4
        mov     r0,a
        mov     a,r1
        subb    a,#4
        mov     r1,a
        mov     a,@r0
        xrl     a,@r1
        mov     @r0,a
        clr     c
        pop     acc
        mov     r4,a
        pop     acc
        mov     r7,a
        pop     acc
        mov     r2,a
        pop     acc
        ret
fp_prehod:
        mov     a,r7
        push    acc
        mov     r7,#5
fp_prehod1:
        mov     fp_stack,@r0
        mov     a,@r1
        mov     @r1,fp_stack
        mov     @r0,a
        inc     r0
        inc     r1
        djnz    r7,fp_prehod1
        mov     a,r0
        clr     c
        subb    a,#5
        mov     r0,a
        mov     a,r1
        subb    a,#5
        mov     r1,a
        pop     acc
        mov     r7,a
        ret
fp_plus:
        push    acc
        mov     a,r7
        push    acc
        mov     a,r4
        push    acc
        mov     a,r1
        push    acc
        mov     a,r0
        push    acc
        lcall   fp_norma3
        mov     a,r4
        mov     r0,a
        mov     r1,#fp_stack+16
        mov     r7,#3
        clr     c
fp_add5:dec     r0
        dec     r1
        mov     a,@r1
        addc    a,@r0
        mov     @r1,a
        djnz    r7,fp_add5
        clr     a
        dec     r1
        addc    a,#0
        mov     @r1,a
        mov     a,r0
        add     a,#3
        mov     r4,#6
        lcall   fp_normalizace
        pop     acc
        push    acc
        inc     a
        mov     r0,a
        mov     r1,#fp_stack+13
        mov     r7,#3
fp_add6:mov     a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        djnz    r7,fp_add6
        pop     acc
        mov     r0,a
        pop     acc
        mov     r1,a
        pop     acc
        mov     r4,a
        pop     acc
        mov     r7,a
        pop     acc
        ret
fp_add:
        push    acc
        lcall   fp_sign
        jz      fp_ad_nula
        mov     a,r0
        push    acc
        mov     a,r1
        mov     r0,a
        lcall   fp_sign
        mov     r0,a
        pop     acc
        xch     a,r0
        jz      fp_ad_nula1
        mov     a,@r0
        jnz     fp_plus1
        mov     a,@r1
        jnz     fp_plus2

        lcall   fp_plus
        sjmp    fp_add_konec
fp_plus2:
        mov     @r1,#0
        lcall   fp_minus
        sjmp    fp_add_konec
fp_plus1:
        mov     a,@r1
        jnz     fp_plus3

        mov     @r0,#0h
        lcall   fp_prehod
        lcall   fp_minus
        sjmp    fp_add_konec
fp_plus3:
        lcall   fp_plus
fp_add_konec:
        pop     acc
        ret
fp_ad_nula:
        mov     a,r0
        push    acc
        mov     a,r1
        push    acc
        xch     a,r0
        mov     r1,a
        lcall   fp_copy
        pop     acc
        mov     r1,a
        pop     acc
        mov     r0,a
        pop     acc
        ret
fp_ad_nula1:
        lcall   fp_copy
        pop     acc
        ret
fp_su_nula:
        lcall   fp_copy
        mov     a,@r0
        jz      fp_su_nul1
        mov     @r0,#0
        pop     acc
        ret
fp_su_nul1:
        mov     @r0,#0FFh
        pop     acc
        ret
fp_subb:
        push    acc
        lcall   fp_sign
        jz      fp_ad_nula
        mov     a,r0
        push    acc
        mov     a,r1
        mov     r0,a
        lcall   fp_sign
        mov     r0,a
        pop     acc
        xch     a,r0
        jz      fp_su_nula
        mov     a,@r0
        jnz     fp_minus1
        mov     a,@r1
        jnz     fp_minus2

        lcall   fp_minus
        sjmp    fp_subb_konec
fp_minus2:
        mov     @r1,#0
        lcall   fp_plus
        sjmp    fp_subb_konec
fp_minus1:
        mov     a,@r1
        jnz     fp_minus3

        mov     @r1,#0ffh
        lcall   fp_plus
        sjmp    fp_subb_konec
fp_minus3:
        mov     @r0,#0
        mov     @r1,#0
        lcall   fp_minus
        mov     a,@r0
        cpl     a
        mov     @r0,a
fp_subb_konec:
        pop     acc
        ret
fp_minus:
        push    acc
        mov     a,r7
        push    acc
        mov     a,r4
        push    acc
        mov     a,r1
        push    acc
        mov     a,r0
        push    acc
        lcall   fp_norma3
        mov     fp_stack+2,#0
        mov     a,r4
        dec     a
        dec     a
        dec     a
        mov     r0,a
        mov     a,@r0
        clr     c
        subb    a,fp_stack+13
        jc      fp_subb10
        jnz     fp_subb15
        inc     r0
        mov     a,@r0
        clr     c
        subb    a,fp_stack+14
        jc      fp_subb10
        jnz     fp_subb15
        inc     r0
        mov     a,@r0
        clr     c
        subb    a,fp_stack+15
        jc      fp_subb10
        sjmp    fp_subb15
fp_subb10:
        mov     a,r4
        dec     a
        mov     r0,a
        mov     a,@r0
        mov     @r0,fp_stack+15
        mov     fp_stack+15,a
        dec     r0
        mov     a,@r0
        mov     @r0,fp_stack+14
        mov     fp_stack+14,a
        dec     r0
        mov     a,@r0
        mov     @r0,fp_stack+13
        mov     fp_stack+13,a
        mov     fp_stack+2,#0ffh
fp_subb15:
        mov     a,r4
        mov     r0,a
        mov     r1,#fp_stack+16
        mov     r7,#3
        clr     c
fp_subb2:dec    r0
        dec     r1
        mov     a,@r0
        subb    a,@r1
        mov     @r1,a
        djnz    r7,fp_subb2
        dec     r0
        pop     acc
        push    acc
        mov     fp_stack,a
        xrl     a,r0
        jz      fp_subb1
        mov     a,fp_stack+2
        cpl     a
        mov     fp_stack+2,a
        mov     r0,fp_stack
fp_subb1:
        inc     r0
        mov     @r0,fp_stack+13
        inc     r0
        mov     @r0,fp_stack+14
        inc     r0
        mov     @r0,fp_stack+15
        mov     a,fp_stack+2
        jz      fp_subb11
        pop     acc
        push    acc
        mov     r0,a
        mov     a,@r0
        cpl     a
        mov     @r0,a
fp_subb11:
        pop     acc
        mov     r0,a
        pop     acc
        mov     r1,a
        pop     acc
        mov     r4,a
        pop     acc
        mov     r7,a
        pop     acc
        ret
fp_norma3:
        mov     a,r2
        push    acc
        mov     a,r1
        push    acc
        mov     a,r0
        push    acc
        lcall   smaz_stack
        mov     a,r1
        add     a,#3
        mov     r1,a
        mov     r0,#fp_stack+15
        lcall   fp_kopie
        mov     a,r1
        add     a,#4
        push    acc
        mov     r4,#3
        lcall   fp_normal2
        pop     acc
        mov     r0,a
        dec     r0
        mov     r1,#fp_stack+15
        lcall   fp_kopie

        lcall   smaz_stack
        pop     acc
        push    acc
        add     a,#3
        mov     r1,a
        mov     r0,#fp_stack+15
        lcall   fp_kopie
        mov     a,r1
        add     a,#4
        push    acc
        mov     r4,#3
        lcall   fp_normal2
        pop     acc
        mov     r0,a
        dec     r0
        mov     r1,#fp_stack+15
        lcall   fp_kopie
        pop     acc
        mov     r0,a
        pop     acc
        mov     r1,a
        push    acc
        mov     a,r0
        push    acc
        lcall   smaz_stack
        mov     a,r0
        add     a,#4
        mov     r0,a
        mov     a,r1
        add     a,#4
        mov     r1,a
        mov     a,@r0
        clr     c
        subb    a,@r1
        jc      fp_addl2
        mov     r2,a
        mov     a,r0
        mov     r4,a
        mov     a,r1
        mov     r0,a
        sjmp    fp_addl4
fp_addl2:
        cpl     a
        inc     a
        mov     r2,a
        mov     a,r1
        mov     r4,a
        mov     a,@r0
        add     a,r2
        mov     @r0,a
fp_addl4:
        mov     r7,#3
        mov     r1,#fp_stack+16
fp_addl3:
        dec     r1
        dec     r0
        mov     a,@r0
        mov     @r1,a
        djnz    r7,fp_addl3
        mov     a,r2
        jz      fp_addi_ok
        lcall   fp_norma2
fp_addi_ok:
        pop     acc
        mov     r0,a
        pop     acc
        mov     r1,a
        pop     acc
        mov     r2,a
        ret
fp_norma2:


        mov     r1,#fp_stack+13
        mov     r7,#3
        mov     r0,#fp_stack
        mov     b,#0
fp_nor_zmensi1:
        mov     a,b
        swap    a
        mov     b,a
        mov     a,@r1
        anl     a,#0f0h
        swap    a
        orl     a,b

        mov     b,#0ah
        div     ab
        anl     a,#0fh
        swap    a
        mov     @r0,a
        mov     a,b
        swap    a
        mov     b,a
        mov     a,@r1
        anl     a,#0fh
        orl     a,b

        mov     b,#0ah
        div     ab
        anl     a,#0fh
        orl     a,@r0
        mov     @r0,a
        inc     r0
        inc     r1
        djnz    r7,fp_nor_zmensi1
        lcall   smaz_pul2_stack
        mov     a,r0
        clr     c
        subb    a,#fp_stack
        mov     r7,a
        dec     r0
        mov     r1,#fp_stack+15
fp_nor_zmensi2:
        mov     a,@r0
        mov     @r1,a
        dec     r0
        dec     r1
        djnz    r7,fp_nor_zmensi2
        lcall   smaz_pul_stack
        djnz    r2,fp_norma2
        ret
fp_toascii:
        mov a,r0
        push acc
        lcall   smaz_stack
        inc     r0
        mov     fp_stack+15,#1
        mov     r7,#24
fp_print1:
        inc     r0
        inc     r0
        mov     a,@r0
        mov     c,acc.0
        dec     r0
        dec     r0
        mov     a,@r0
        rrc     a
        mov     @r0,a
        inc     r0
        mov     a,@r0
        rrc     a
        mov     @r0,a
        inc     r0
        mov     a,@r0
        rrc     a
        mov     @r0,a
        dec     r0
        dec     r0
        jnc     fp_print2
        mov     r0,#fp_stack+7
        mov     r1,#fp_stack+15
        mov     r4,#4
        clr     c
fp_print4:
        mov     a,@r1
        addc    a,@r0
        da      a
        mov     @r0,a
        dec     r0
        dec     r1
        djnz    r4,fp_print4
        pop     acc
        push    acc
        mov     r0,a
        inc     r0
fp_print2:
        mov     r1,#fp_stack+15
        mov     r4,#4
        clr     c
fp_print3:
        mov     a,@r1
        addc    a,@r1
        da      a
        mov     @r1,a
        dec     r1
        djnz    r4,fp_print3
        djnz    r7,fp_print1
        mov     r0,#fp_stack
        mov     r1,#fp_stack+4
        mov     r7,#4
fp_print5:
        mov     a,@r1
        swap    a
        anl     a,#0fh
        add     a,#'0'
        mov     @r0,a
        inc     r0
        mov     a,@r1
        anl     a,#0fh
        add     a,#'0'
        mov     @r0,a
        inc     r1
        inc     r0
        djnz    r7,fp_print5
        pop acc
        ret
SMAZ_STACK:
        MOV     A,R1
        PUSH    ACC
        MOV     R7,#16
        MOV     R1,#fp_stack
SMAZ_STACK1:
        MOV     @R1,#0
        INC     R1
        DJNZ    R7,SMAZ_STACK1
        POP     ACC
        MOV     R1,A
        RET
SMAZ_PUL_STACK:
        MOV     A,R1
        PUSH    ACC
        MOV     R7,#8
        MOV     R1,#fp_stack
        SJMP    SMAZ_STACK1
SMAZ_PUL2_STACK:
        MOV     A,R1
        PUSH    ACC
        MOV     R7,#8
        MOV     R1,#fp_stack+8
        SJMP    SMAZ_STACK1
